import React, { useState } from 'react';
import { RGMask, NumberMask, CEPMask, CNPJMask, CPFMask, NoSpaceMask, PhoneMask, maskValue } from './mask.utils';

export interface IPropsMask {
   value: string; // valor
   mask?: 'CEP' | 'CNPJ' | 'CPF' | 'RG' | 'phone' | 'number' | 'no-spaces'; // máscara do input
   withoutDotNumber?: boolean; // quando mask for 'number', não mostra pontos nas casas de 1000
   decimals?: number; // quando mask for 'number', quantidade de decimais
}

export const MaskText: React.FunctionComponent<IPropsMask> = (props: IPropsMask) => {
   const newVal = maskValue(props.value, props.mask, props as any);

   return <>{newVal}</>;
};
